package gs.db;

import gs.db.database;
import gs.db.query;
import java.util.Hashtable;
import java.sql.ResultSet;

public class user extends database {

  public String login     ; // unique key
  public String gspwd     ; //
  public String firstname ; //
  public String midname   ; //
  public String lastname  ; // 
  public String email     ; //
  public String dept      ; // 
  public String npaclogin ; //
  public String url       ; //
  public String picurl    ; //
  public String phone     ; //
  public String room      ; //

  public user() {} // a user object with null fields

  public user(String login, String gspwd, 
              String firstname, String midname, String lastname,
              String email, String dept, String npaclogin, String url, String picurl,
              String phone, String room) {

     this.login     = login; 
     this.gspwd     = gspwd; 
     this.firstname = firstname; 
     this.midname   = midname;
     this.lastname  = lastname; 
     this.email     = email; 
     this.dept      = dept; 
     this.npaclogin = npaclogin; 
     this.url       = url; 
     this.picurl    = picurl; 
     this.phone     = phone; 
     this.room      = room; 
  }
  
  public user( String login ) 
       throws Exception
  {
    String queryString = "SELECT * from "+ getTableName() +
      " WHERE login ='"+ login +"'";
    try {
      ResultSet rs = query.queryData( queryString );
      if( rs.next() )
	{
	  fields.put("login", (String)rs.getString("login"));
	  fields.put("gspwd", (String)rs.getString("gspwd"));
	  fields.put("firstname", (String)rs.getString("firstname")); 
	  fields.put("midname", (String)rs.getString("midname"));
	  fields.put("lastname", (String)rs.getString("lastname")); 
	  fields.put("email", (String)rs.getString("email")); 
	  fields.put("dept", (String)rs.getString("dept")); 
	  fields.put("npaclogin", (String)rs.getString("npaclogin")); 
	  fields.put("url", (String)rs.getString("url")); 
	  fields.put("picurl", (String)rs.getString("picurl")); 
	  fields.put("phone", (String)rs.getString("phone")); 
	  fields.put("room", (String)rs.getString("room")); 
	} else {
	  throw new Exception("User could not be found.");
	}
    } catch(Exception e) {
      throw e;
    }
  }
  
  public static Hashtable getFields(String login)
       throws Exception
  {
    return new user(login).getFields(); // super class' method
  }

  public static Hashtable getEmptyFields()
       throws Exception
  {
    Hashtable result = new Hashtable();
    result.put("login", "");
    result.put("gspwd", "");
    result.put("firstname", ""); 
    result.put("midname", "");
    result.put("lastname", ""); 
    result.put("email", ""); 
    result.put("dept", ""); 
    result.put("npaclogin","" ); 
    result.put("url", ""); 
    result.put("picurl", ""); 
    result.put("phone", ""); 
    result.put("room", ""); 

    return result;
  }

  public String getTableName()
  {
    return "users";
  }

  // used in SQL INSERT command
  public String getFieldNames()
  {
    return "login,gspwd,firstname,midname,lastname,"+
      "email,dept,npaclogin,url,picurl,phone,room";
  }

  // used in SQL INSERT command
  public String getFieldValues()
  {
    return "'"+ login +"','"+ gspwd +"','"+ firstname +"','"+ midname +"','"+
       lastname +"','"+ email +"','"+ dept + "','"+
       npaclogin +"','"+ url +"','"+ picurl +"','"+ phone +"','"+ room +"'";
  }

  // used in SQL UPDATE command
  public String getSetValues()
  {
    return "login='"+ login 
      +"',gspwd='"+ gspwd 
      +"',firstname='"+ firstname 
      +"',midname='"+ midname 
      +"',lastname='"+ lastname
      +"',email='"+ email 
      +"',dept='"+ dept 
      +"',npaclogin='"+ npaclogin
      +"',url='"+ url 
      +"',picurl='"+ picurl 
      +"',phone='"+ phone 
      +"',room='"+ room;
  }

  public String updateSQL() 
  {
    return updateSQL("login='"+ login +"'");
  }

  public static String delete(String login) 
  {
    return new user().deleteSQL("login='"+ login +"'");
  }

  public String deleteSQL() 
  {
    return deleteSQL("login='"+ login +"'");
  }

}
