package gs.html;

import java.util.StringTokenizer;
import java.util.Hashtable;

import java.sql.ResultSet;

public class RecordParser
       implements gs.html.RecordParsable
{
  ResultSet rs;
  String fieldNames;
  
  public RecordParser(ResultSet rs, String fieldNames)
  {
    this.rs = rs;
    this.fieldNames = fieldNames;
  }
  
  public boolean handleRecord(Hashtable fields)
       throws java.io.IOException, java.sql.SQLException
  {
    if(rs.next()) 
      {
	StringTokenizer names = new StringTokenizer(fieldNames, " ,");;
	String aField;
	while(names.hasMoreElements()) 
	  {
	    aField = names.nextToken();
	    fields.put(aField, rs.getString(aField));
	  }
	return true;
      }
    return false;
  }
}
