package gs.db;

//import gs.object.aUser;
import gs.db.database;
import gs.db.query;
import java.util.Hashtable;
import java.sql.ResultSet;

public class dbUser extends database {

  public       String gslogin;          // unique key
  public       String gspwd    ;
  public       String idnum;
  public    String firstname;
  public    String midname  ;
  public    String lastname ;
  public       String privilige;
  public       String ACL; 
  public          String email     ; 
  public          String dept      ; 
  public          String url       ;
  public          String picurl    ;
  public          String phone     ;
  public          String room      ;
  public          String systemslogin;
  public    String comments  ;
  public    String reserved;
  static String tablename="users";

  public dbUser(String login, String gspwd, String idnum,
	       String privilige,String ACL,
	       String firstname, String midname, String lastname,
	       String email, String dept,String url, String picurl,
	       String phone, String room,String systemslogin,
	       String comments , String reserved) {

     this.gslogin     = login; 
     this.gspwd     = gspwd; 
     this.idnum     = idnum; 

     this.firstname = firstname; 
     this.midname   = midname;
     this.lastname  = lastname; 

     this.email     = email; 
     this.dept      = dept; 
     this.url       = url; 
     this.picurl    = picurl; 
     this.phone     = phone; 
     this.room      = room; 
     this.systemslogin = systemslogin; 
     this.comments  = comments;
     this.reserved  = reserved;
  }
  public dbUser(  )       
  
  {}
  public dbUser( String login )        throws Exception
  {
    String queryString = "SELECT * from "+ getTableName() +
       " WHERE gslogin ='"+ login +"'";
  try {
      ResultSet rs = query.queryData( queryString );
      System.out.println("dbUser:queryString:"+queryString);
      if( rs.next() )
	{
	  fields.put("gslogin", (String)rs.getString("gslogin"));
	  fields.put("gspwd", (String)rs.getString("gspwd"));
	  fields.put("idnum", (String)rs.getString("idnum"));
	  fields.put("ACL", (String)rs.getString("ACL"));
	  fields.put("privilige", (String)rs.getString("privilige"));
	  System.out.println((String)fields.get("privilige"));
	  fields.put("firstname", (String)rs.getString("firstname")); 
	  fields.put("midname", (String)rs.getString("midname"));
	  fields.put("lastname", (String)rs.getString("lastname")); 
	  fields.put("email", (String)rs.getString("email")); 
	  fields.put("dept", (String)rs.getString("dept")); 
	  fields.put("url", (String)rs.getString("url")); 
	  fields.put("picurl", (String)rs.getString("picurl")); 
	  fields.put("phone", (String)rs.getString("phone")); 
	  fields.put("room", (String)rs.getString("room")); 
	  fields.put("systemslogin", (String)rs.getString("systemslogin")); 
	  fields.put("comments", (String)rs.getString("comments")); 
	  fields.put("reserved", (String)rs.getString("reserved")); 

	} else {
	 
	  throw new Exception("dbUser:UserNotFound: User could not be found.(dbUser)");
	}
    } catch(Exception e) {
       e.printStackTrace();
      throw e;
    }
  }
  

  
  public static String checkUserID (String id) throws Exception {
    String queryString = "SELECT gslogin from "+ tablename +
       " WHERE idnum ='"+ id +"'";
    try {
      ResultSet rs = query.queryData( queryString );
      System.out.println("dbUser:queryString:checkUserID:"+queryString);
      if( rs.next() )
	{
	  return (String)rs.getString("gslogin");
	} else {
	  return null;
	}
    } catch(Exception e) {
       e.printStackTrace();
      throw e;
    }
  }
  public static Hashtable getFields(String login)  throws Exception
  {
    return new dbUser(login).getFields(); // super class' method
  }

  public static Hashtable getEmptyFields()
       throws Exception
  {
    Hashtable result = new Hashtable();
    result.put("gslogin", "");
    result.put("gspwd", "");
    result.put("idnum", "");
    result.put("privilige", "5"); 
    result.put("ACL", ""); 
    result.put("firstname", ""); 
    result.put("midname", "");
    result.put("lastname", ""); 
    result.put("email", ""); 
    result.put("dept", ""); 
    result.put("url", ""); 
    result.put("picurl", ""); 
    result.put("phone", ""); 
    result.put("room", ""); 
    result.put("systemslogin","" ); 
    result.put("comments","" ); 
    result.put("reserved","" ); 

    return result;
  }

  public String getTableName()
  {
    return tablename;
  }
  //<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  // used in SQL INSERT command
  public String getFieldNames()
  {
    return "gslogin,gspwd,idnum,"+
      "privilige,ACL,"+
      "firstname,midname,lastname,"+
      "email,dept,url,picurl,phone,room,systemslogin,"+
      "comments,reserved";
  }

  // used in SQL INSERT command
  public String getFieldValues()
  {
    return "'"+ gslogin +"','"+ gspwd +"','"+ idnum+"','"+ 
      privilige +"','"+ ACL +"','"+
      firstname +"','"+ midname +"','"+ lastname +"','"+ 
      email +"','"+ dept + "','"+ url +"','"+ 
      picurl +"','"+ phone +"','"+room +"','"+
      systemslogin +"','"+comments +"','"+reserved+"'";
  }

  //>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

  // used in SQL UPDATE command
  public String getSetValues()
  {
    return "gslogin='"+ gslogin 
      +"',gspwd='"+ gspwd 
      +"',idnum='"+idnum
      +"',privilige='"+privilige 
      +"',ACL='"+ACL

      +"',firstname='"+ firstname 
      +"',midname='"+ midname 
      +"',lastname='"+ lastname

      +"',email='"+ email 
      +"',dept='"+ dept 
      +"',url='"+ url 
      +"',picurl='"+ picurl 
      +"',phone='"+ phone 
      +"',room='"+ room

      +"',systemslogin='"+ systemslogin
      +"',comments='"+ comments
      +"',reserved='"+ reserved
      +"'";
  }
  //_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
  //            OPERATIONS
  // \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \

  //CONSIDER LATER
  public String updateSQL()   {
    return updateSQL("gslogin='"+ gslogin +"'");
  }
  public void update()throws Exception {
      update.updateData( updateSQL() );
  }

  public static void  delete(String _login) throws Exception{
    String sqlcommand=new dbUser().deleteSQL("gslogin='"+ _login +"'");
    update.updateData(sqlcommand );
  }
  //CONSIDER LATER
  public String deleteSQL() {
    return deleteSQL("gslogin='"+ gslogin +"'");
  }

  public void add()throws Exception {
      update.updateData( insertSQL() );
  }

}







