/*
 * Copyright (c) 1996 WebLogic, Inc.  All Rights Reserved.
 */

//package tutorial.jdbc.oracle;

import java.sql.*;
import java.util.Properties;
import com.imaginary.sql.msql.*;

public class login {

  public static void main(String argv[])
    throws Exception
  {

    // You can connect to a database with JDBC in various ways.
    // Command line arguments and explicit Properties are both optional

    // One way is to invoke java with: 
    // java -Djdbc.drivers=weblogic.jdbc.oci.Driver classname
    // and to then use

    Properties props = new Properties();
    props.put("user",     "balsoy");
    props.put("password", "ozgur");
    props.put("server",   "iona.npac.syr.edu");
    props.put("port",     "1114");

    try {
      Connection conn1 = DriverManager.getConnection("jdbc:msql", props);
      conn1.close();
      System.out.println("Logged in #1.");
    }
    catch (SQLException e) {
      System.out.println("Did you set the -Djdbc.drivers=weblogic.jdbc.oci.Driver on the command line?");
      throw e;
    }

    // If you do not want to set the jdbc.drivers property on the command line,
    // then you can use
    Driver d = new MsqlDriver();
    Connection conn2 = d.connect("jdbc:msql", props);
    conn2.close();
    System.out.println("Logged in #2.");

    // The simplest thing to do is to not use Properties and embed the server name in the URL
    Class.forName("com.imaginary.sql.msql.MsqlDriver");
    Connection conn3 = DriverManager.getConnection("jdbc:msql://osprey8.npac.syr.edu:1114/bookmarks","balsoy","ozgur");
    conn3.close();

    System.out.println("Logged in #3.");



  }

}
