package gs.admin;

import org.w3c.dom.*;

import java.io.PrintWriter;
import java.io.IOException;

import javax.servlet.ServletException;
import javax.servlet.ServletOutputStream;

import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import gs.dbxml.dbxQuiz;
import gs.dbxml.dbxQuestion;
import gs.dbxml.dbxAnswers;
import gs.db.dbStudent;

import java.util.Hashtable;
import java.util.Enumeration;




/**
 */
public class xTakeExam extends xGeneric {

    /**
     * Service the request.
     *
     * @exception  ServletException if there is any sort of Exception
     *
     */

  public void  serveCommand(PrintWriter printer,String unum,String course,String command,
			    HttpServletRequest req) throws Exception{
    System.out.println("\n@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@\n "+req.getPathTranslated()  );

    //SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS
    //ASK PERMISSION above does not ask any permission
    //SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS
    if (!unum.equals("1"))
      sys.accessPermission(unum,course,"QUIZZES:"+command);
    //SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS
    String quizname=req.getParameter("quizname");

    if(command.equals("LIST")) 
      listQuizzes(printer, unum, course,  false);

    else if(command.equals("TAKEQUIZ")) {
      Document edoc=dbxQuiz.makeExam(course,quizname);
      parseXML(printer,unum,edoc,"quizEXAMTIME","takingExam");
    }
    else if(command.equals("LISTQUESTIONS"))
      {
	dbxQuestion dxq = new dbxQuestion(course,quizname );
	parseXML(printer,unum,dxq.doc,"questionEXAMLIST","listQuestions");
      }
    else {
      boolean FORCE=false; //instructor
      String accesscode=req.getParameter("accesscode");
      //accesscode=dbStudent.getAccesscode(unum);

      if(command.equals("GRADEEXAM")) 
	{
	  processExam(printer,unum,course,quizname,req);

	}
      else if(command.equals("LISTGRADEDQUESTIONS"))
	{
	  returnQuestionResults(printer,unum,accesscode,course,quizname,req,FORCE);
	}
      else if(command.equals("RESULT")) 
	{
	  returnResults(printer,unum,accesscode,course,quizname,req,FORCE);

	}
//       else if(command.equals("LISTGRADEDQUESTIONSBYI"))
// 	{
// 	  returnQuestionResults(printer,unum,req.getParameter("accesscode"),course,quizname,req);
// 	}
//       else if(command.equals("RESULTBYI")) 
// 	{
// 	  returnResults(printer,unum,req.getParameter("accesscode"),course,quizname,req);

// 	}

    }
  }



  //--------------------------------------------------------------------//
  //Reads Student fields from the html request form
  //--------------------------------------------------------------------//
  public dbxQuiz readQuizFields(HttpServletRequest req) throws Exception {

    dbxQuiz q=new dbxQuiz();
    q.fields=readFields(req);
    try 
      { 
	q.setIdentification();
      } 
    catch (Exception e) 
      {
	throw new Exception("Please enter  all the fields in red!");
      }
    return q;
  }

  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  // listQuizzes
  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  void listQuizzes (PrintWriter printer, String unum, 
		    String course,  boolean allFields)
       throws Exception, IOException 
  {
    dbxQuiz dxq = new dbxQuiz();
    Document d= dxq.listQuizzesInXML( course );
    parseXML(printer,unum,d,"quizEXAMLIST","listQuizzes");
  }
//   //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
//   // prepareQuiz
//   //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

//   void  prepareQuiz(PrintWriter printer, String unum, 
// 		   String course,String quizname)
//        throws Exception, IOException 
//   { 
//     dbxQuiz dxq = new dbxQuiz(course,quizname);
//     dxq.checkAvailability();
//     Document d=dxq.fillQuestions();
//   System.out.println("  @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@");
//     parseXML(printer,unum,d,"quizEXAMTIME","takingExam");
//   }

 //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  // processExam
  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  void  processExam(PrintWriter printer, String unum, 
		   String course,String quizname,HttpServletRequest req) throws Exception
  {
    unum=dbStudent.getAccesscode(unum);
    unum="1";
    dbxQuiz dxq = new dbxQuiz(course,quizname);

    if (dxq.available()) {

      Document edoc=dbxQuiz.makeExam(dxq);
      dbxAnswers dxa = new dbxAnswers(unum,course,quizname);
      int score=grade(unum,course,quizname,edoc,storeResults(dxa,req) );
      //   int score=grade(unum,course,quizname,edoc,dxa.getAnswers(unum,course,quizname) );
      dxa.storeGrade(score);

      if (dxq.published()){
	parseXML(printer,unum,edoc,"quizEXAMGRADED","takenExam");
      } else {
	parseXML(printer,unum,edoc,"quizNOT","notpublished");
      }
    } else {
      parseXML(printer,unum,null,"quizNOT","notavailable");
    }
  }  
  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  // storeResults
  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  public Hashtable storeResults(dbxAnswers dxa,HttpServletRequest  req) throws Exception {

    Hashtable ht=new Hashtable();
    for (Enumeration e = req.getParameterNames() ; e.hasMoreElements() ;) {
      String name=(String)e.nextElement();
      System.out.println(name);
      if ( name.startsWith ("ans")) {
	String qid=name.substring(3);
	String [] stdans=req.getParameterValues(name);
	String merge="";
	if (stdans !=null) 
	  for (int i=0;i<stdans.length;i++) {
	    ht.put(qid+stdans[i],"1");
	    merge+=stdans[i]+"<|>";
	  }
	dxa.storeAnswers(merge,qid);
	System.out.println("ht.put(stdans[i],qid);   "+merge+","+qid);
      }
    }
    return ht;
}


  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  // grade
  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  public int grade(String unum,String course,String quizname, Document e,
			Hashtable ht) throws Exception {

    int totalscore=0;
    int totalpoints=0;

    NodeList elements = sys.xml.getElements(e,"course/quiz","question");      
    int elementCount = elements.getLength();
                          System.out.println("iiiiiiiiiiielementCountiiii"+ elementCount);
    for (int i = 0; i < elementCount; i++) {
                          System.out.println("iiiiiiiiiiiiiii"+i);
      Element question = (Element)elements.item(i);
      String type=sys.xml.getTxt(question,"type");
      
      try {
	totalpoints+=sys.xml.getInt(question,"points");
      } catch (Exception e1){ throw new Exception("Missing quiz information, please report");}
      try {
	if (type.equals("mc"))
	  totalscore+=gradeMC (e,question,ht);
      } catch (Exception e2){}
     
    }
    
    Element quiz=sys.xml.get(e,"quiz"); 
    int qzpoints=sys.xml.getInt(quiz,"points");
    int finalscore=totalscore*qzpoints/totalpoints;
    sys.xml.addMyTextNode(e,quiz,"std-total"   ,Integer.toString(finalscore));
    return finalscore;
  }

  public int gradeMC(Document d,Element question, Hashtable ht) throws Exception {
	int points=sys.xml.getInt(question,"points");
	String qid=sys.xml.getTxt(question,"qid");
	int qscore=0;
	NodeList answers = question.getElementsByTagName("answer");
	int ansCount = answers.getLength();
	for (int a = 0; a < ansCount; a++) {
	  Element answer = (Element)answers.item(a);
	  String text=sys.xml.getTxt(answer,"text");
	  if (ht.get(qid+text)!= null) {
	    int val=sys.xml.getInt(answer,"val");
	    qscore+=val;
	    sys.xml.addMyTextNode(d,answer,"std-selected"   ,"YES");
	  }
	}
	String scoring=sys.xml.getTxt(question,"scoring");
	int stdscore=0;
	if (scoring.equals("nc") && qscore < points)  {
	   stdscore=0;
	} else {
	  stdscore=qscore;
	}
	sys.xml.addMyTextNode(d,question,"std-score"   ,Integer.toString(stdscore));
	return stdscore;
  }
//   public Hashtable storeGetAnswersMC(HttpServletRequest  req, String qid) throws Exception {

//     Hashtable ht=new Hashtable();
//     dbxAnswers dxa = new dbxAnswers(course,quizname);
   
//     for (Enumeration e = req.getParameterNames() ; e.hasMoreElements() ;) {
//       String name=e.nextElement();
// 	System.out.println(name);
// 	if ( name.startsWith ("ans")) {
// 	  String [] stdans=req.getParameterValues(name);
// 	  if (stdans !=null) 
// 	    for (int i=0;i<stdans.length;i++) {
// 	      ht.put(stdans[i],qid);
// 	      System.out.println("ht.put(stdans[i],qid);   "+stdans[i]);
// 	    }
// 	}
// 	return ht;
//     }

 //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  // processExam
  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  void  returnResults(PrintWriter printer, String unum, String accesscode, 
		   String course,String quizname,HttpServletRequest req,boolean FORCE) throws Exception
  {
	unum=dbStudent.getAccesscode(unum);
	unum="1"; accesscode="1";
    dbxQuiz dxq = new dbxQuiz(course,quizname);

    if (dxq.published() ||FORCE ) {

      Document edoc=dbxQuiz.makeExam(dxq);
      dbxAnswers dxa = new dbxAnswers(accesscode,course,quizname);
      //     int score=grade(unum,course,quizname,edoc,storeResults(dxa,req) );
      int score=grade(accesscode,course,quizname,edoc,dxa.getAnswers(unum,course,quizname) );
      dxa.storeGrade(score);
      if (FORCE) 
      parseXML(printer,unum,edoc,"quizEXAMGRADED","takenExam");
      } else {
	//parseXML(printer,unum,null,"quizNOTPUBLISHED","takenExam");
	//printer.println("<html><body bgcolor=white><font color=red><p>Quiz results are not published yet");
	throw new Exception("Exam results are not published yet");
      }
  }  
  void  returnQuestionResults(PrintWriter printer, String unum, String accesscode, 
		   String course,String quizname,HttpServletRequest req,boolean FORCE) throws Exception
  {
    unum=dbStudent.getAccesscode(unum);
    unum="1"; accesscode="1";
    dbxQuiz dxq = new dbxQuiz(course,quizname);

    if (dxq.published()||FORCE ) {
      Document edoc=dbxQuiz.makeExam(dxq);
      dbxAnswers dxa = new dbxAnswers(accesscode,course,quizname);
      int score=grade(accesscode,course,quizname,edoc,dxa.getAnswers(unum,course,quizname) );
      //int score=grade(unum,course,quizname,edoc,storeResults(dxa,req) );
      //dxa.storeGrade(score);
      parseXML(printer,unum,edoc,"quizQUESTIONSCORES-S","listGradedQuestions");
    } else {
      dbxQuestion dxqn = new dbxQuestion(course,quizname );
      parseXML(printer,unum,dxqn.doc,"questionEXAMLIST","listQuestionsNOLINK");
    }
  }  

} //class close

