package gs.admin;

import org.w3c.dom.*;

import java.io.PrintWriter;
import java.io.IOException;

import javax.servlet.ServletException;
import javax.servlet.ServletOutputStream;

import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;


import gs.dbxml.dbxQuestion;






/**
 */
public class xQuestions extends xGeneric {

    /**
     * Service the request.
     *
     * @exception  ServletException if there is any sort of Exception
     *
     */

  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  // serveCommand
  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    public void  serveCommand(PrintWriter printer,String unum,String course,String command,HttpServletRequest req) throws Exception{
	 //SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS
	 //ASK PERMISSION above does not ask any permission
	 //SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS
      // sys.accessPermission(unum,course,"xQUESTIONS:"+command);
	 //SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS
	 String quizname=req.getParameter("quizname");

	 if(command.equals("LISTQUESTIONS")) 
	   listQuestions(printer, unum, course,quizname,  false);

	 else if(command.equals("SHOWQUESTION"))
	   browseQuestion(printer, unum, course,quizname, req.getParameter("qid"),"don't reload");

	 else if(command.equals("NEW"))
	   newQuestion(printer, unum, course,quizname);
	 else if(command.equals("CANCEL")) {
	   printer.println("<script language=JavaScript> history.go(-2);</script>");
	 }
	 else if(command.equals("EDIT"))
	    editQuestion(printer, unum, course,quizname,  req.getParameter("qid"));
	 else if(command.equals("UPDATE")) 
	   updateQuestion(printer, unum,   readQuestionFields(req));
	 else if(command.equals("ADD")) 
	   addQuestion(printer, unum, course, readQuestionFields(req));
	 else if(command.equals("DELETE")) {
	   dbxQuestion.delete(course,quizname,req.getParameter("qid"));
	   printer.println("<b>Question information has been succesfully deleted!</b><script language=JavaScript> top.menu.document.location.reload();</script>");
	 }
  }


  //--------------------------------------------------------------------//
  //Reads Student fields from the html request form
  //--------------------------------------------------------------------//
  public dbxQuestion readQuestionFields(HttpServletRequest req) throws Exception {
    dbxQuestion q=new dbxQuestion();
    q.fields=readFields(req);
    try { q.setIdentification();
    } catch (Exception e) {
      throw new Exception("Please enter  all the fields in red!");
    }
    return q;
  }
  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  // listQuestions
  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  void listQuestions (PrintWriter printer, String unum, 
		    String course, String quizname, boolean allFields)
       throws Exception, IOException 
  {
    dbxQuestion dxq = new dbxQuestion(course,quizname);
    parseXML(printer,unum,dxq.doc,null,"listQuestions");
  }
  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  // browseQuestion
  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  void  browseQuestion(PrintWriter printer, String unum, 
		   String course,String quizname,String qid,String  reload)
       throws Exception, IOException 
  {
    dbxQuestion dxq = new dbxQuestion(course,quizname,qid);
    parseXML(printer,unum,dxq.doc,null,"browseQuestion");
  }
  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  // editQuestion
  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  void  editQuestion(PrintWriter printer, String unum, 
		   String course,String quizname,String qid)
       throws Exception, IOException 
  {
    dbxQuestion dxq = new dbxQuestion(course,quizname,qid);
    Document d= dxq.QuestionInXML();
    parseXML(printer,unum,d,"/editmode","editQuestion");
 
  }
  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  // updateQuestion
  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  void updateQuestion(PrintWriter printer, String unum,dbxQuestion dbq)
       throws Exception,IOException
  {
    parseXML(printer,unum,dbq.update(),null,"updateQuestion");
  }

  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  // addQuestion
  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  void addQuestion(PrintWriter printer, String unum,String course, dbxQuestion dbq)
       throws Exception,IOException
  {
    parseXML(printer,unum,dbq.add(),null,"addQuestion");
  }

  //--------------------------------------------------------------------//
  // newQuestion
  //--------------------------------------------------------------------//  
  void newQuestion  (PrintWriter printer, String unum,String course,String quizname)
       throws  Exception, IOException
  {
    parseXML(printer,unum,new dbxQuestion().dbxQuestion(course,quizname),"/newmode","newQuestion");

    //  dbxQuestion q=new dbxQuestion(course,quizname);
//     Document d= q.QuestionInXML();
//     parseXML(printer,unum,d,"/newmode","newQuestion");
  }

   
  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  // deleteQuestion
  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  void  deleteQuestion(PrintWriter printer, String unum, 
		   String course,String quizname,String qid,String answer)
       throws Exception, IOException 
  {
    dbxQuestion.delete(course,quizname,qid);
    // parseXML(printer,unum,d,"/editmode","editQuestion");
    printer.println("<b>Question information has been succesfully deleted!</b><script language=JavaScript> top.menu.document.location.reload();</script>");
 
  }


} //class close

