package gs.db;

import gs.db.query;
import java.util.Hashtable;
import java.sql.ResultSet;

public class course extends database 
{
  public String reference ; // unique key
  public String code      ; //
  public String term      ; //
  public String year      ; //
  public String title     ; // 
  public String days      ; //
  public String times     ; //
  public String room      ; // 
  public String grading   ; //
  public String url       ; //
  public String comments  ; //

  public course() {}

  public course(String reference, 
		String code, String term, String year,
		String title,
		String days, String times, String room,
		String grading, 
		String url,
		String comments) {
    
     this.reference = reference ; 
     this.code      = code; 
     this.term      = term;
     this.year      = year ; 
     this.title     = title; 
     this.days      = days; 
     this.times     = times; 
     this.room      = room; 
     this.grading   = grading ; 
     this.url       = url; 
     this.comments  = comments; 
  }

  public course(String reference) 
       throws Exception
  {
    String queryString = "SELECT * from "+ getTableName() +
      " WHERE reference ='"+ reference +"'";
    
    try {
      ResultSet rs = query.queryData( queryString );
      if( rs.next() )
	{
	  fields.put("reference", (String)rs.getString("reference"));
	  fields.put("code", (String)rs.getString("code"));
	  fields.put("term", (String)rs.getString("term")); 
	  fields.put("year", (String)rs.getString("year"));
	  fields.put("title", (String)rs.getString("title")); 
	  fields.put("days", (String)rs.getString("days")); 
	  fields.put("times", (String)rs.getString("times")); 
	  fields.put("room", (String)rs.getString("room")); 
	  fields.put("grading", (String)rs.getString("grading")); 
	  fields.put("url", (String)rs.getString("url")); 
	  fields.put("comments", (String)rs.getString("comments")); 
	} else {
	  throw new Exception("Course could not be found.");
	}
    } catch(Exception e) {
      throw e;
    }
  }

  public static Hashtable getEmptyFields()
       throws Exception
  {
    Hashtable fields = new Hashtable();
    fields.put("reference", "");
    fields.put("code", "");
    fields.put("term", ""); 
    fields.put("year", "");
    fields.put("title", ""); 
    fields.put("days", ""); 
    fields.put("times", ""); 
    fields.put("room", ""); 
    fields.put("grading", ""); 
    fields.put("url", ""); 
    fields.put("comments", "");
    return fields;
  }

  public String getTableName()
  {
    return "courses";
  }

  // used in SQL INSERT command
  public String getFieldNames()
  {
    return "reference,code,term,year,"+
      "title,days,times,room,grading,url,comments";
  }

  // used in SQL INSERT command
  public String getFieldValues()
  {
    return "'"+ reference +"','"+ code +"','"+ term +"','"+ year
      +"','"+ title +"','"+ days +"','"+ times + "','"+ room 
      +"','"+ grading +"','"+ url +"','"+ comments +"'";
  }

  // used in SQL UPDATE command
  public String getSetValues()
  {
    return "reference='"+reference
      +"',code='"+code
      +"',term='"+term
      +"',year='"+year
      +"',title='"+title
      +"',days='"+days
      +"',times='"+times
      +"',room='"+room
      +"',grading='"+grading
      +"',url='"+url
      +"',comments='"+comments+"'";
  }

  public String updateSQL() 
  {
    return updateSQL("reference='"+ reference +"'"); // super class' method
  }

  public static String delete(String reference) 
  {
    return new course().deleteSQL("reference='"+ reference +"'"); // super class' method
  }

  public String deleteSQL() 
  {
    return deleteSQL("reference='"+ reference +"'"); // super class' method
  }

  public static Hashtable getFields(String reference) 
       throws Exception
  {
    return new course(reference).getFields(); // super class' method
  }

}
