package gs.db;

import gs.db.query;
import java.util.Hashtable;
import java.sql.ResultSet;

public class student extends database 
{
  public String ssn       ; // unique key
  public String gspwd     ; //
  public String firstname ; //
  public String midname   ; //
  public String lastname  ; // 
  public String student_id; //
  public String email     ; //
  public String dept      ; // 
  public String year      ; //
  public String login     ; //
  public String unixpwd   ; //
  public String url       ; //

  public student() {}

  public student(String ssn) 
       throws Exception
  {
    String queryString = "SELECT * from "+ getTableName() +
      " WHERE ssn ='"+ ssn +"'";
    
    try {
      ResultSet rs = query.queryData( queryString );
      if( rs.next() )
	{
	  fields.put("ssn", (String)rs.getString("ssn"));
	  fields.put("gspwd", (String)rs.getString("gspwd"));
	  fields.put("firstname", (String)rs.getString("firstname")); 
	  fields.put("midname", (String)rs.getString("midname"));
	  fields.put("lastname", (String)rs.getString("lastname")); 
	  fields.put("email", (String)rs.getString("email")); 
	  fields.put("dept", (String)rs.getString("dept")); 
	  fields.put("login", (String)rs.getString("login")); 
	  fields.put("url", (String)rs.getString("url")); 
	  fields.put("unixpwd", (String)rs.getString("unixpwd")); 
	  fields.put("year", (String)rs.getString("year")); 
	  fields.put("student_id", (String)rs.getString("student_id")); 
	} else {
	  throw new Exception("Student could not be found.");
	}
    } catch(Exception e) {
      throw e;
    }
  }

  public student(String ssn, String gspwd,
                 String firstname, String midname, String lastname,
                 String student_id,
                 String email,
                 String dept,
                 String year,
                 String login, String unixpwd,
                 String url ) 
  {
     this.ssn       = ssn; 
     this.gspwd     = gspwd; 
     this.firstname = firstname; 
     this.midname   = midname;
     this.lastname  = lastname; 
     this.student_id= student_id; 
     this.email     = email; 
     this.dept      = dept; 
     this.year      = year; 
     this.login     = login; 
     this.unixpwd   = unixpwd; 
     this.url       = url; 
  }

  public String getTableName()
  {
    return "students";
  }

  // used in SQL INSERT command
  public String getFieldNames()
  {
    return "ssn,gspwd,firstname,midname,lastname,"+
      "student_id,email,dept,year,login,unixpwd,url";
  }

  // used in SQL INSERT command
  public String getFieldValues()
  {
    return "'"+ ssn +"','"+ gspwd +"','"+ firstname +"','"+ midname +"','"+
      lastname +"','"+ student_id +"','"+ email +"','"+ dept + "','"+
      year +"','"+ login +"','"+ unixpwd +"','"+ url +"'";
  }

  // used in SQL UPDATE command
  public String getSetValues()
  {
    return "ssn='"+ ssn
      +"',gspwd='"+ gspwd 
      +"',firstname='"+ firstname 
      +"',midname='" + midname 
      +"',lastname='"+ lastname
      +"',email='"+ email 
      +"',dept='"+ dept 
      +"',login='"+ login
      +"',url='"+ url 
      +"',unixpwd='"+ unixpwd 
      +"',student_id='"+ student_id 
      +"',year='"+ year +"'";
  }

  public String updateSQL() 
  {
    return updateSQL("ssn='"+ ssn +"'"); // super class' method
  }

  public static String delete(String ssn) 
  {
    return new student().deleteSQL("ssn='"+ ssn +"'"); // super class' method
  }

  public String deleteSQL() 
  {
    return deleteSQL("ssn='"+ ssn +"'"); // super class' method
  }

  public static Hashtable getFields(String ssn) 
       throws Exception
  {
    return new student(ssn).getFields(); // super class' method
  }

  public static Hashtable getEmptyFields()
       throws Exception
  {
    Hashtable result = new Hashtable();
    result.put("ssn", "");
    result.put("gspwd", "");
    result.put("firstname",""); 
    result.put("midname", "");
    result.put("lastname", ""); 
    result.put("email", ""); 
    result.put("dept", ""); 
    result.put("login", ""); 
    result.put("url", ""); 
    result.put("unixpwd", ""); 
    result.put("year", ""); 
    result.put("student_id", ""); 

    return result;
  }
}
