package gs.admin;

import gs.conf.Configuration;
import java.util.Hashtable;

import java.io.IOException;
import javax.servlet.ServletException;

import javax.servlet.ServletOutputStream;

import gs.db.U;
import gs.db.dbUser;

import gs.html.Html;
import gs.html.Parser;
import gs.html.RecordParser;

import gs.cache.UserCache;
import gs.cache.CourseCache;
import gs.cache.StudentCache;
import gs.cache.AssignmentCache;

public class gSystem {
  public static String host="http://osprey7.npac.syr.edu:5757";
  public static String home="http://osprey7.npac.syr.edu:5757/HtdocsGrdSys/";
  public static String localdir="/home/B10E/msen7/oserver/";
  public static String images="http://osprey7.npac.syr.edu:5757/HtdocsGrdSys/images";
  public static String htdocs="HtdocsGrdSys/";
  public static String cgi="http://osprey7.npac.syr.edu:5757/DB";
  
  public static String admin="admin/";
  public static String servlet="GS";

  public static String style ="<link rel='stylesheet' type='text/css' href='/Grading/styles.css'>";
  public static String bgcolor="white";  
  public static String background="none.gif";  
  
  public static UserCache usr_cache;
  public static CourseCache crs_cache;
  public static StudentCache std_cache;
  public static AssignmentCache asgn_cache;

  public gSystem ()
  { Configuration.loadConfiguration();}
 
  public static void globalValues(Hashtable ht,String unum){
    ht.put("host",host);
    ht.put("cgi",cgi);
    ht.put("servlet",servlet);
    ht.put("images",images );
    ht.put("style",style);
    ht.put("bgcolor",bgcolor);
    ht.put("background",  background);   
    ht.put("unum",unum);
 }


  public static void error (ServletOutputStream err,String message) throws IOException, ServletException {
    Hashtable ht = new Hashtable();
    ht.put("error",message);
    globalValues(ht,"");
    String templateFile=localdir+htdocs+admin+"error.html";
    try {
      Parser.parseHtml(templateFile, ht, err);
    } catch( Exception e ) {
      e.printStackTrace();
      err.println("<h2>ERROR : "+e.getMessage()+" while printing error page</h2>");
    }
  }

  public boolean accessPermission(String unum,String course, String request)
       throws Exception 
  {
    dbUser u=usr_cache.get(unum);
    String ACL=(String) u.fields.get("ACL");
    int  PRIVILIGE=Integer.parseInt((String) u.fields.get("privilige"));
    if ( PRIVILIGE<=U.SUPER
	 || ACL.indexOf(course) >=0
	 || course.indexOf("ALL") >=0
	 || request.indexOf("COURSE_RECORDS") >=0 ) {
      //............................GRADING............................
      if (request.indexOf("GRADING_RECORDS:") >=0) {
	
	if (request.indexOf("GRMENU") >=0 )
	  { /*if (PRIVILIGE<=U.)  everybody*/return true;}
	else if (request.indexOf("Assignments listed") >=0 )
	  {/*if (PRIVILIGE<=U.) everybody*/return true;}
	else if (request.indexOf("LISTASSIGNMENTS") >=0 )
	  {/*if (PRIVILIGE<=U.) everybody*/return true;}
	else if (request.indexOf("INFO") >=0 )
	  {/*if (PRIVILIGE<=U.) everybody*/return true;}
	else if (request.indexOf("GRADEASSIGNMENT") >=0 )
	  {if (PRIVILIGE<=U.TA) return true;}
	else if (request.indexOf("UPDATE_A_GRADE") >=0 )
	  {if (PRIVILIGE<=U.TA) return true;}
	else if (request.indexOf("UPDATE_A_STUDENT") >=0 )
	  {if (PRIVILIGE<=U.TA) return true;}
	else if (request.indexOf("SHOWSTUDENTGRADES") >=0 )
	  {if (PRIVILIGE<=U.TA) return true;}
	else if (request.indexOf("Students listed") >=0 )
	  {/*if (PRIVILIGE<=U.)everybody*/ return true;}
	else if (request.indexOf("LISTSTUDENTS") >=0 )
	  {/*if (PRIVILIGE<=U.)everybody*/ return true;}
	else if (request.indexOf("GRADESTUDENT") >=0 )
	  {if (PRIVILIGE<=U.TA) return true;}
	else if (request.indexOf("Statistics") >=0 )
	  {/*if (PRIVILIGE<=U.) everybody*/return true;}
	else if (request.indexOf("AVERAGE_ST") >=0 )
	  {/*if (PRIVILIGE<=U.) everybody*/return true;}
	else if (request.indexOf("RANKS") >=0 )
	  {/*if (PRIVILIGE<=U.) everybody*/return true;}
	else if (request.indexOf("RECALCULATE") >=0 )
	  {/*if (PRIVILIGE<=U.) everybody*/return true;}
	else if (request.indexOf("GRADE_ST") >=0 )
	  {/*if (PRIVILIGE<=U.) everybody*/return true;}
	else if (request.indexOf("Survey") >=0 )
	  {/*if (PRIVILIGE<=U.) everybody*/return true;}
	else if (request.indexOf("LISTSURVEYS") >=0 )
	  {/*if (PRIVILIGE<=U.) everybody*/return true;}

	else if (request.indexOf("SHOWSURVEY") >=0 )
	  {if (PRIVILIGE<=U.TA) return true;}
	else if (request.indexOf("Set Options") >=0 )
	  {/*if (PRIVILIGE<=U.) everybody*/return true;}
	else if (request.indexOf("SETOPTION") >=0 )
	  {if (PRIVILIGE<=U.TA) return true;}
	 
	//System.out.println(" ! ! ! ! SECURITY CHECK ! ! ! ! request ="+request );
	
	}
    //............................ASSIGNMENT............................
      else if (request.indexOf("ASSIGNMENT_RECORDS:") >=0 ) {
	if (request.indexOf("BROWSE") >=0 )
	  {if (PRIVILIGE<=U.BROWSER) return true;}
	else if (request.indexOf("MAIN") >=0 )
	  {if (PRIVILIGE<=U.BROWSER) return true;}
	else if (request.indexOf("LIST") >=0 )
	  {if (PRIVILIGE<=U.BROWSER) return true;}
	else if (request.indexOf("LISTALL") >=0 )
	  {if (PRIVILIGE<=U.BROWSER) return true;}
	else if (request.indexOf("SHOW") >=0 )
	  {if (PRIVILIGE<=U.TA) return true;}
	else if (request.indexOf("NEW") >=0 )
	  {if (PRIVILIGE<=U.TA) return true;}
	else if (request.indexOf("SKIP") >=0 )
	  {if (PRIVILIGE<=U.BROWSER) return true;}
	else if (request.indexOf("INFO") >=0 )
	  {if (PRIVILIGE<=U.BROWSER) return true;}
        else if (request.indexOf("CANCEL") >=0 )
	  {if (PRIVILIGE<=U.BROWSER) return true;}
	else if (request.indexOf("EDIT") >=0 )
	  {if (PRIVILIGE<=U.TA) return true;}
	else if (request.indexOf("DELETE") >=0 )
	  {if (PRIVILIGE<=U.TA) return true;}
	else if (request.indexOf("UPDATE") >=0 )
	  {if (PRIVILIGE<=U.TA) return true;}
	else if (request.indexOf("ADD") >=0 )
	  {if (PRIVILIGE<=U.TA) return true;}
	else if (request.indexOf("BEFORELOGIN") >=0 )
	  {if (PRIVILIGE<=U.BROWSER) return true;}
        else if (request.indexOf("Post Office") >=0 )
	  {if (PRIVILIGE<=U.BROWSER) return true;}
	else if (request.indexOf("Class List") >=0 )
	  {if (PRIVILIGE<=U.BROWSER) return true;}
	else if (request.indexOf("PUBLISH") >=0 )
	  {if (PRIVILIGE<=U.TA) return true;}
      }
    //............................COURSE............................
      else if (request.indexOf("COURSE_RECORDS:") >=0 ) {
	if (request.indexOf("BROWSE") >=0 )
	  {if (PRIVILIGE<=U.BROWSER) return true;}
	else if (request.indexOf("NEW COURSE") >=0 )
	  {if (PRIVILIGE<=U.INSTRUCTOR) return true;}
	else if (request.indexOf("INFO") >=0 )
	  {if (PRIVILIGE<=U.BROWSER) return true;}
	else if (request.indexOf("EDIT") >=0 )
	  {if (PRIVILIGE<=U.INSTRUCTOR) return true;}
	else if (request.indexOf("REMOVE") >=0 )
	  {if (PRIVILIGE<=U.INSTRUCTOR) return true;}
	else if (request.indexOf("UPDATE COURSE") >=0 )
	  {if (PRIVILIGE<=U.INSTRUCTOR) return true;}
	else if (request.indexOf("ADD COURSE") >=0 )
	  {if (PRIVILIGE<=U.INSTRUCTOR) return true;}
	else if (request.indexOf("GRDCUSTOMIZEFORM") >=0 )
	  {if (PRIVILIGE<=U.INSTRUCTOR) return true;}
	else if (request.indexOf("ADD(overwrite) GRADE") >=0 )
	  {if (PRIVILIGE<=U.INSTRUCTOR) return true;}
	else if (request.indexOf("DELETE GRADE") >=0 )
	  {if (PRIVILIGE<=U.INSTRUCTOR) return true;}
	else if (request.indexOf("QUESTIONS") >=0 )
	  {if (PRIVILIGE<=U.BROWSER) return true;}
	else if (request.indexOf("ADD(overwrite) question") >=0 )
	  {if (PRIVILIGE<=U.INSTRUCTOR) return true;}
	else if (request.indexOf("DELETE selected questions") >=0 )
	  {if (PRIVILIGE<=U.INSTRUCTOR) return true;}
	else if (request.indexOf("QUESTIONAIRE") >=0 )
	  {if (PRIVILIGE<=U.BROWSER) return true;}
	else if (request.indexOf("NEW SURVEY") >=0 )
	  {if (PRIVILIGE<=U.BROWSER) return true;}
	else if (request.indexOf("PUBLIC'S VIEW") >=0 )
	  {if (PRIVILIGE<=U.BROWSER) return true;}
	else if (request.indexOf("UPDATE SURVEY") >=0 )
	  {if (PRIVILIGE<=U.BROWSER) return true;}
	else if (request.indexOf("ADD-OVERWRITE SURVEY") >=0 )
	  {if (PRIVILIGE<=U.INSTRUCTOR) return true;}
	else if (request.indexOf("DELETE SURVEY") >=0 )
	  {if (PRIVILIGE<=U.INSTRUCTOR) return true;}
      }
    //............................STUDENT............................
      else if (request.indexOf("STUDENT_RECORDS:") >=0 ) {
	if (request.indexOf("BROWSE") >=0 )
	  {if (PRIVILIGE<=U.BROWSER) return true;}
	else if (request.indexOf("MAIN") >=0 )
	  {if (PRIVILIGE<=U.BROWSER) return true;}
	else if (request.indexOf("LIST") >=0 )
	  {if (PRIVILIGE<=U.BROWSER) return true;}
	else if (request.indexOf("LISTALL") >=0 )
	  {if (PRIVILIGE<=U.BROWSER) return true;}
	else if (request.indexOf("SHOW") >=0 )
	  {if (PRIVILIGE<=U.TA) return true;}
	else if (request.indexOf("NEW") >=0 )
	  {if (PRIVILIGE<=U.TA) return true;}
	else if (request.indexOf("SKIP") >=0 )
	  {if (PRIVILIGE<=U.BROWSER) return true;}
	else if (request.indexOf("INFO") >=0 )
	  {if (PRIVILIGE<=U.BROWSER) return true;}
        else if (request.indexOf("CANCEL") >=0 )
	  {if (PRIVILIGE<=U.BROWSER) return true;}
	else if (request.indexOf("EDIT") >=0 )
	  {if (PRIVILIGE<=U.TA) return true;}
	else if (request.indexOf("DELETE") >=0 )
	  {if (PRIVILIGE<=U.TA) return true;}
	else if (request.indexOf("UPDATE") >=0 )
	  {if (PRIVILIGE<=U.TA) return true;}
	else if (request.indexOf("ADD") >=0 )
	  {if (PRIVILIGE<=U.TA) return true;}
	else if (request.indexOf("BEFORELOGIN") >=0 )
	  {if (PRIVILIGE<=U.BROWSER) return true;}
        else if (request.indexOf("Post Office") >=0 )
	  {if (PRIVILIGE<=U.BROWSER) return true;}
	else if (request.indexOf("Class List") >=0 )
	  {if (PRIVILIGE<=U.BROWSER) return true;}
      }
    //----------------------------USER----------------------------
      else if (request.indexOf("USER_RECORDS:") >=0 ) {
	if (PRIVILIGE<=U.SUPER) return true;
	String comments=(String) u.fields.get("comments");
	if  (request.indexOf("MAIN") >=0 )
	  {if (comments.indexOf("distinguished User")>=0) return true; }
	else if (request.indexOf("list") >=0 )
	  {if (comments.indexOf("distinguished User")>=0) return true; }
	else if (request.indexOf("LISTALL") >=0 )
 	  {if (comments.indexOf("distinguished User")>=0) return true; }
	else if (request.indexOf("FRAME") >=0 )
	  {if (comments.indexOf("distinguished User")>=0) return true; }
        else if (request.indexOf("SHOW") >=0 )
	  {if (comments.indexOf("distinguished User")>=0) return true; }
	else if (request.indexOf("NEW") >=0 )
	  {if (comments.indexOf("distinguished User")>=0) return true; }
	else if (request.indexOf("NEWRECORD") >=0 )
	  {if (comments.indexOf("distinguished User")>=0) return true; }
	else if (request.indexOf("INFO") >=0 )
	  {if (comments.indexOf("distinguished User")>=0) return true; }
	else if (request.indexOf("CANCEL") >=0 )
	  {if (comments.indexOf("distinguished User")>=0) return true; }
	else if (request.indexOf("EDIT") >=0 )
	  {if (comments.indexOf("distinguished User")>=0) return true; }
        else if (request.indexOf("EDITRECORD") >=0 )
 	  {if (comments.indexOf("distinguished User")>=0) return true; }
	else if (request.indexOf("DELETE") >=0 )
	    ;
	else if (request.indexOf("UPDATE") >=0 )
	    ;
	else if (request.indexOf("ADD") >=0 )
	    ;
      }
    //----------------------------SERVICES----------------------------
      else if (request.indexOf("SERVICE:") >=0 ) {
	if (request.indexOf("Password Assignment") >=0 )
	 {if (PRIVILIGE<=U.SYSTEM) return true;}
       else if (request.indexOf("CHANGE")>=0)
	 {if (PRIVILIGE<=U.TA) return true;}
       else if (request.indexOf("Preferences")>=0)
	 {if (PRIVILIGE<=U.TA) return true;}
       else if (request.indexOf("PREFERENCES")>=0)
	 {if (PRIVILIGE<=U.SUPER) return true;}
       else if (request.indexOf("Backup") >=0 )
	 {if (PRIVILIGE<=U.SUPER) return true;}
       else if (request.indexOf("Majordomo Subscription") >=0 )
	 {if (PRIVILIGE<=U.SYSTEM) return true;}
       else if (request.indexOf("Post Office") >=0 )
	 {if (PRIVILIGE<=U.BROWSER) return true;}
       else if (request.indexOf("Class List") >=0 )
	 {if (PRIVILIGE<=U.BROWSER) return true;}
      }

    }
    throw new Exception("You do not have privileges to continue! <br>"+request+"<br>P:"+PRIVILIGE);
  }
}

