package gs.db;
import java.sql.ResultSet;

public interface RecordHandler {

  // Each database record is sent to this subroutine,
  // formatted here, finally is returned.
  //
  // Child classes should override this method.
  abstract public void handleRecord(ResultSet rs, StringBuffer output) 
                  throws java.sql.SQLException;
}
