#################################################################
#---------------------------LAYOUS-------------------------------
#################################################################
CREATE TABLE layouts (

	course 		CHAR(50) NOT NULL,
	page  		CHAR(50) NOT NULL,
	layoutname 	CHAR(50) NOT NULL,
	file	 	CHAR(200)

) \g

CREATE UNIQUE  INDEX index_layouts ON layouts (
        course,
	page,
	layoutname
	
) \g

######################################################
#delete from layouts \g
#drop table layouts \g
delete from layouts where page like '%question'\g
delete from layouts where page like 'quizLIST'\g
delete from layouts where page = 'quizQUESTIONS'\g
delete from layouts where page = 'quizQUESTIONSCORES'\g
delete from layouts where page = 'quizQUESTIONSCORES-I'\g
delete from layouts where page = 'questionANSWERS'\g
delete from layouts where page = 'qbQUESTION'\g
delete from layouts where page = 'qbGRADE'\g
delete from layouts where page = 'qbEDIT_META'\g
delete from layouts where page = 'qbNEW'\g
delete from layouts where page = 'quiz'\g

select * from layouts \g
select file from layouts \g
select page,layoutname from layouts \g

select * from layouts where page like 'quiz%' \g
select * from layouts where page like 'question%' \g
select * from layouts where page = 'quiz' \g


######################################################

insert into layouts values ('all'    ,'quiz'         ,'show in table','/npac/home/msen7/TESTSVR/HtdocsGrdSys/quizzes/quizshow.xsl') \g
insert into layouts values ('CPS616Spring99'    ,'quiz'         ,'show in text','/npac/home/msen7/TESTSVR/HtdocsGrdSys/quizzes/quizshow.xsl') \g
 insert into layouts values ('all'    ,'quizLIST'     ,'first','/npac/home/msen7/TESTSVR/HtdocsGrdSys/quizzes/quizlist.xsl') \g
 insert into layouts values ('all'    ,'quizLIST'     ,'fourth','/npac/home/msen7/TESTSVR/HtdocsGrdSys/quizzes/quizlist.xsl') \g
 insert into layouts values ('all'    ,'quizLIST'     ,'third','/npac/home/msen7/TESTSVR/HtdocsGrdSys/quizzes/quizlist.xsl') \g
 insert into layouts values ('all'    ,'quizEDIT'     ,'edit','/npac/home/msen7/TESTSVR/HtdocsGrdSys/quizzes/quizedit.xsl') \g
 insert into layouts values ('all'    ,'quizEXAMLIST' ,'EXAMLIST','/npac/home/msen7/TESTSVR/HtdocsGrdSys/exam/quizlist.xsl') \g
 insert into layouts values ('all'    ,'quizEXAMTIME' ,'EXAMLIST','/npac/home/msen7/TESTSVR/HtdocsGrdSys/exam/exam.xsl') \g
 insert into layouts values ('all'    ,'quizEXAMGRADED' ,'QUESTIONLIST','/npac/home/msen7/TESTSVR/HtdocsGrdSys/exam/grade.xsl') \g
 insert into layouts values ('all'    ,'quizQUESTIONSCORES-S','QUESTIONLIST','/npac/home/msen7/TESTSVR/HtdocsGrdSys/exam/questionlist.xsl') \g
 insert into layouts values ('all'    ,'quizNOT' ,'results','/npac/home/msen7/TESTSVR/HtdocsGrdSys/exam/not.xsl') \g
 insert into layouts values ('all'    ,'quizRESULT' ,'results','/npac/home/msen7/TESTSVR/HtdocsGrdSys/quizzes/results.xsl') \g
 insert into layouts values ('all'    ,'quizRESULTSTUDENTS' ,'results','/npac/home/msen7/TESTSVR/HtdocsGrdSys/quizzes/students.xsl') \g
 insert into layouts values ('all'    ,'quizGradeChanged' ,'gchange','/npac/home/msen7/TESTSVR/HtdocsGrdSys/exam/gradechange.xsl') \g

insert into layouts values ('all'    ,'question'     ,'browse','/npac/home/msen7/TESTSVR/HtdocsGrdSys/questions/show.xsl') \g
 insert into layouts values ('all'    ,'questionLIST' ,'newq1','/npac/home/msen7/TESTSVR/HtdocsGrdSys/questions/list.xsl') \g
 insert into layouts values ('all'    ,'questionMETA' ,'browse','/npac/home/msen7/TESTSVR/HtdocsGrdSys/questions/showmeta.xsl') \g
 insert into layouts values ('all'    ,'questionEXAMLIST' ,'QUESTIONLIST','/npac/home/msen7/TESTSVR/HtdocsGrdSys/exam/questionlist.xsl') \g
 insert into layouts values ('all'    ,'questionEDIT_META','edit','/npac/home/msen7/TESTSVR/HtdocsGrdSys/questions/edit.xsl') \g
 insert into layouts values ('all'    ,'questionGRADE','grading','/npac/home/msen7/TESTSVR/HtdocsGrdSys/questions/grade.xsl') \g
 insert into layouts values ('all'    ,'questionSCORES-I','QUESTIONLIST','/npac/home/msen7/TESTSVR/HtdocsGrdSys/quizzes/questionlistScores.xsl') \g
 insert into layouts values ('all'    ,'questionANSWERS','QUESTION','/npac/home/msen7/TESTSVR/HtdocsGrdSys/questions/answers.xsl') \g

INSERT INTO layouts  VALUES ('all','qbQUESTION','browse','/npac/home/msen7/TESTSVR/HtdocsGrdSys/questions/show.xsl') \g
 INSERT INTO layouts  VALUES ('all','qbLIST','qblist','/npac/home/msen7/TESTSVR/HtdocsGrdSys/qb/list.xsl') \g
 INSERT INTO layouts  VALUES ('all','qbMETA','browse','/npac/home/msen7/TESTSVR/HtdocsGrdSys/qb/showmeta.xsl') \g
 insert into layouts  values ('all','qbEDIT_META','edit','/npac/home/msen7/TESTSVR/HtdocsGrdSys/questions/edit.xsl') \g
 insert into layouts  values ('all','qbGRADE','grading','/npac/home/msen7/TESTSVR/HtdocsGrdSys/questions/grade.xsl') \g
 INSERT INTO layouts  VALUES ('all','qbCOPY','copy','/npac/home/msen7/TESTSVR/HtdocsGrdSys/qb/copy.xsl') \g
 INSERT INTO layouts  VALUES ('all','qbSTORE','store','/npac/home/msen7/TESTSVR/HtdocsGrdSys/qb/store.xsl') \g




#################################################################
---------------------------LAYOUS---END--------------------------
#################################################################
