package gs.admin;

import org.w3c.dom.*;

import java.io.PrintWriter;
import java.io.IOException;

import javax.servlet.ServletException;
import javax.servlet.ServletOutputStream;

import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import gs.dbxml.dbxQuestion;


/**
 */
public class xQuestions extends xGeneric {

  /**
   * Service the request.
   *
   * @exception  ServletException if there is any sort of Exception
   *
   */

  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  // serveCommand
  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  public void  serveCommand(PrintWriter printer,String unum,String course,String command,HttpServletRequest req) throws Exception{
    //SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS
    //ASK PERMISSION above does not ask any permission
    //SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS
    // sys.accessPermission(unum,course,"xQUESTIONS:"+command);
    //SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS
    String quizname=req.getParameter("quizname");

    if(command.equals("LISTQUESTIONS")) 
      {
	dbxQuestion dxq = new dbxQuestion(course,quizname);
	parseXML(printer,unum,dxq.doc,null,"listQuestions");
      }
    else if(command.equals("SHOWQUESTION"))
      {
	dbxQuestion dxq = new dbxQuestion(course,quizname,req.getParameter("qid"));
	parseXML(printer,unum,dxq.doc,null,"browseQuestion");
      }
    else if(command.equals("NEW"))
      parseXML(printer,unum,new dbxQuestion().dbxQuestion(course,quizname),"/newmode","newQuestion"); 

    else if(command.equals("CANCEL")) 
      printer.println("<script language=JavaScript> history.go(-2);</script>");

    else if(command.equals("UPDATE")) 
      parseXML(printer,unum,readQuestionFields(req).update(),null,"updateQuestion"); 

    else if(command.equals("ADD")) 
      parseXML(printer,unum,readQuestionFields(req).add(),null,"addQuestion");  

    else if(command.equals("EDIT"))
      {
	dbxQuestion dxq = new dbxQuestion(course,quizname,req.getParameter("qid"));
	parseXML(printer,unum,dxq.QuestionInXML(),"/editmode","editQuestion");
      }
    else if(command.equals("DELETE")) 
      {
	dbxQuestion.delete(course,quizname,req.getParameter("qid"));
	printer.println("<b>Question information has been succesfully deleted!</b><script language=JavaScript> top.menu.document.location.reload();</script>");
      }
  }


  //--------------------------------------------------------------------//
  //Reads Student fields from the html request form
  //--------------------------------------------------------------------//
  public dbxQuestion readQuestionFields(HttpServletRequest req) throws Exception {
    dbxQuestion q=new dbxQuestion();
    q.fields=readFields(req);
    try 
      { 
	q.setIdentification();
      } 
    catch (Exception e) 
      {
	throw new Exception("Please enter  all the fields in red!");
      }
    return q;
  }

} //CLASS xQuestions close


