package gs.admin;

import org.w3c.dom.*;

import java.io.PrintWriter;
import java.io.IOException;

import javax.servlet.ServletException;
import javax.servlet.ServletOutputStream;

import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import gs.dbxml.dbxQB;
import gs.dbxml.dbxQuestion;
import gs.dbxml.dbxQuiz;
import gs.dbxml.dbxAnswers;

import java.util.Hashtable;
import java.util.Enumeration;
/**
 */
public class xQGrader extends xGeneric {

  /**
   * Service the request.
   *
   * @exception  ServletException if there is any sort of Exception
   *
   */

  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  // serveCommand
  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  public void  serveCommand(PrintWriter printer,String unum,String course,String command,HttpServletRequest req) throws Exception{
    //SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS
    //ASK PERMISSION above does not ask any permission
    //SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS
    // sys.accessPermission(unum,course,"xQGrader:"+command);
    //SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS
    String quizname=req.getParameter("quizname");
    if(command.equals("GRADEQUESTION")) 
      {
	dbxQuestion dxq = new dbxQuestion(course,quizname,req.getParameter("qid"));
	Document grdoc=grade(dxq.doc,req);
	parseXML(printer,unum,grdoc,"questionGRADE","");

      }
    else if(command.equals("GRADEQUESTIONFROMQB")) {
	dbxQB dxq = new dbxQB(course,quizname,req.getParameter("qid"));
	Document grdoc=grade(dxq.doc,req);
	parseXML(printer,unum,grdoc,"qbGRADE","");
      }
    else if(command.equals("LISTQUESTIONSCORES-I"))
      {
	dbxQuestion dxq = new dbxQuestion(course,quizname);
	parseXML(printer,unum,dxq.doc,"questionSCORES-I","listQuestions");
      }
    else if(command.equals("QUIZRESULTS"))
      {
	returnQuizResults(printer,unum,course,quizname,req);
      }
    else if(command.equals("QUESTIONANSWERS"))
      {
	returnQuestionResults(printer,unum,course,quizname,req.getParameter("qid"),req);
      }
    else if(command.equals("LISTSTUDENTS"))
      {
	returnStudents(printer,unum,course,quizname,req);
      }
    else if(command.equals("METADATA"))
      {
	dbxQuestion dxq = new dbxQuestion(course,quizname,req.getParameter("qid"));
	parseXML(printer,unum,dxq.doc,"questionMETA","browseQuestion");
      }
    else if(command.equals("QUESTION"))
      {
	dbxQuestion dxq = new dbxQuestion(course,quizname,req.getParameter("qid"));
	parseXML(printer,unum,dxq.doc,"question","browseQuestion");
      }
    else if(command.equals("NEW"))
      parseXML(printer,unum,new dbxQuestion().dbxQuestion(course,quizname),"NEWquestion","newQuestion"); 

    else if(command.equals("CANCEL")) 
      printer.println("<script language=JavaScript> history.go(-2);</script>");

    else if(command.equals("UPDATE")) 
      parseXML(printer,unum,readQuestionFields(req).update(),"METAquestion","updateQuestion"); 

    else if(command.equals("SAVE")) 
      parseXML(printer,unum,readQuestionFields(req).update(),"question","browseQuestion"); 
    else if(command.equals("DELETEANSWER")) 
      parseXML(printer,unum,readQuestionFields(req).update(),"question","browseQuestion"); 
    else if(command.equals("ADDANSWER")) 
      parseXML(printer,unum,readQuestionFields(req).update(),"question","browseQuestion"); 

    else if(command.equals("GRADE")) 
      parseXML(printer,unum,readQuestionFields(req).update(),"question","browseQuestion"); 

    else if(command.equals("ADD")) 
      parseXML(printer,unum,readQuestionFields(req).add(),"METAquestion","addQuestion");  

    else if(command.equals("EDIT"))
      {
	dbxQuestion dxq = new dbxQuestion(course,quizname,req.getParameter("qid"));
	parseXML(printer,unum,dxq.QuestionInXML(),"EDIT_METAquestion","editQuestion");
      }
    else if(command.equals("DELETE")) 
      {
	dbxQuestion.delete(course,quizname,req.getParameter("qid"));
	printer.println("<b>Question information has been succesfully deleted!</b><script language=JavaScript> top.menu.document.location.reload();</script>");
      }
  }


  //--------------------------------------------------------------------//
  //Reads Student fields from the html request form
  //--------------------------------------------------------------------//
  public dbxQuestion readQuestionFields(HttpServletRequest req) throws Exception {
    dbxQuestion q=new dbxQuestion();
    q.fields=readFields(req);
    try 
      { 
	q.setIdentification();
      } 
    catch (Exception e) 
      {
	throw new Exception("Please enter  all the fields in red!");
      }
    return q;
  }
  public Document grade(Document q,HttpServletRequest  req) throws Exception {

    int totalscore=0;
    // DocumentFragment qf=d.createDocumentFragment() ;
    // DocumentFragment qf=d.createDocumentFragment() ;
    
    NodeList elements = sys.xml.getElements(q,"course/quiz","question");      
    int elementCount = elements.getLength();
    System.out.println("iiiiiiiiiiielementCountiiii"+ elementCount);
    for (int i = 0; i < elementCount; i++) {
      System.out.println("iiiiiiiiiiiiiii"+i);
      Element question = (Element)elements.item(i);
      String type=sys.xml.getTxt(question,"type");

      if (type.equals("mc")){
	totalscore+=gradeMC (q,question,req);
      }
    }
    
    Element quiz=sys.xml.get(q,"quiz"); 
    sys.xml.addMyTextNode(q,quiz,"std-total"   ,Integer.toString(totalscore));
    return q;
  }
  public int gradeMC(Document d,Element question, HttpServletRequest  req ) throws Exception {
	int points=sys.xml.getInt(question,"points");
	String qid=sys.xml.getTxt(question,"qid");
	
	for (Enumeration e = req.getParameterNames() ; e.hasMoreElements() ;) {
             System.out.println(e.nextElement());

         }
	Hashtable ht=new Hashtable();
	
	String [] stdans=req.getParameterValues("a"+qid);
	if (stdans !=null) 
	  for (int i=0;i<stdans.length;i++) {
	    ht.put(stdans[i],qid);
	    System.out.println("ht.put(stdans[i],qid);"+stdans[i]);
	  }
	int qscore=0;
	NodeList answers = question.getElementsByTagName("answer");
	int ansCount = answers.getLength();
	for (int a = 0; a < ansCount; a++) {
	  Element answer = (Element)answers.item(a);
	  int val=sys.xml.getInt(answer,"val");
	  String text=sys.xml.getTxt(answer,"text");
	  
	  if (ht.get(text)!= null) {
	    qscore+=val;
	    sys.xml.addMyTextNode(d,answer,"std-selected"   ,"YES");

	  }

	}
	String scoring=sys.xml.getTxt(question,"scoring");
	int stdscore=0;
	if (scoring.equals("nc") && qscore < points)  {
	   stdscore=0;
	} else {
	  stdscore=qscore;
	}
	sys.xml.addMyTextNode(d,question,"std-score"   ,Integer.toString(stdscore));
	
	return stdscore;
	
  }

 //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  // 
  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  void  returnQuizResults(PrintWriter printer, String unum, 
		   String course,String quizname,HttpServletRequest req) throws Exception
  {
    dbxQuiz dxq = new dbxQuiz(course,quizname);
    dbxAnswers dxa = new dbxAnswers(course,quizname);
    //    dxa.getGrades(dxq.doc);
    dxa.getGradesNames(dxq.doc);

    parseXML(printer,unum,dxq.doc,"quizRESULT","takenExam");

  }  
 //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  // 
  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  void  returnQuestionResults(PrintWriter printer, String unum, 
		   String course,String quizname,String qid,HttpServletRequest req) throws Exception
  {
    dbxQuestion dxq = new dbxQuestion(course,quizname,qid);
    dbxAnswers dxa = new dbxAnswers(course,quizname);
    dxa.getQuestionAnswers(dxq.doc,qid);

    parseXML(printer,unum,dxq.doc,"questionANSWERS","takenExam");

  }  

 //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  // 
  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  void  returnStudents(PrintWriter printer, String unum, 
		   String course,String quizname,HttpServletRequest req) throws Exception
  {
    dbxQuiz dxq = new dbxQuiz(course,quizname);
    dbxAnswers dxa = new dbxAnswers(course,quizname);
    dxa.getGradesNames(dxq.doc);

    parseXML(printer,unum,dxq.doc,"quizRESULTSTUDENTS","takenExam");

  }  

} //CLASS xQGrader close


	
