package gs.xml;

//XML
import com.ibm.xml.parser.*;
import org.w3c.dom.*;
import com.lotus.xsl.*;
import com.lotus.xsl.xml4j.*;
import com.ibm.xml.parsers.*;

//XML-end
import java.sql.ResultSet;
import gs.db.query;


public class dbXML2  extends xXML {
  String COURSE="all"; // CHANGE LATER WHEN LAYOUT INTERFACE READY!. Now Global Layouts are in use.

  public dbXML2(){}


  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  // getLayout
  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  public static String getXSLFile(String page) throws Exception
  {
    String queryString = "SELECT file from layouts WHERE  page like '"+page+"%'";
    ResultSet rs=query.queryData( queryString );
    String xslfile=null;
    if( rs.next() ) 
           xslfile     = (String)rs.getString("file"); 
    return xslfile; 
  }



  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  // getLayout
  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  public Element getLayout(Document d, String course,String page) throws Exception
  {
    Element current= d.createElement("current"); 
    String queryString = "SELECT * from layouts WHERE course='"+COURSE+"' AND page like '"+page+"%'";
    ResultSet rs=query.queryData( queryString );
    String xslfile ,xsllayout,pagename;
    while( rs.next() ) {
           xslfile     = (String)rs.getString("file"); 
	   xsllayout   = (String)rs.getString("layoutname"); 
	   pagename    = (String)rs.getString("page"); 
	   //System.out.println("\t\tAdding  layout "+xsllayout+"-->"+xslfile);
	   
	   Element layout= d.createElement(pagename); 
	   layout.setAttribute("xname",xsllayout);
	   layout.setAttribute("xfile",xslfile);
	   current.appendChild(layout);
    }
    return current; 
  }




  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  // availableLayouts
  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  public Element availableLayouts(Document d,  String page) throws Exception
  {
    Element layouts= d.createElement("layouts");  // /layouts
    String queryString = "SELECT DISTINCT * from layouts "+" WHERE page like'"+page+"%'";
    //System.out.println  ("\tavailableLayouts:queryString:"+queryString);
    ResultSet rs = query.queryData( queryString );
    String xslfile ,xsllayout,pagename;
    while ( rs.next() )
      {
	 xsllayout   = (String)rs.getString("layoutname"); //luxury
	 xslfile     = (String)rs.getString("file"); //luxury
	 pagename    = (String)rs.getString("page"); 
	 //System.out.println("\t\tAdding  layout "+xsllayout+"-->"+xslfile);

	 Element layout= d.createElement(pagename); 
	 layout.setAttribute("xname",xsllayout);
	 layout.setAttribute("xfile",xslfile);
	 layouts.appendChild(layout);
      }
    return layouts; 
  }






}//class
